#include <stdio.h>
#include <winsock.h>
#include <string.h>
#include <time.h>

extern "C" __declspec( dllexport ) void EMailer(char * v_sender, 
												int * v_sendser_len,
												int * v_sendser_maxlen,
												char * v_receiver, 
												int * v_rec_len,
												int * v_rec_maxlen,
												char * v_host, 
												int * v_host_len,
												int * v_host_maxlen,
												char * v_subject,
												int * v_sub_len,
												int * v_sub_maxlen,
												char * v_body,
												int * v_body_len,
												int * v_body_maxlen
												);

// Un-comment the following line to get output to stdout
//#define  DEBUG

BOOL Ack(SOCKET);
BOOL Post(SOCKET, LPCSTR);


//__declspec( dllexport ) void EMailer(char * v_sender, char * v_receiver, char * v_host, char * v_subject, char * v_body)
__declspec( dllexport ) void EMailer(char * v_sender, 
												int * v_sendser_len,
												int * v_sendser_maxlen,
												char * v_receiver, 
												int * v_rec_len,
												int * v_rec_maxlen,
												char * v_host, 
												int * v_host_len,
												int * v_host_maxlen,
												char * v_subject,
												int * v_sub_len,
												int * v_sub_maxlen,
												char * v_body,
												int * v_body_len,
												int * v_body_maxlen
												)
{




	//Init Winsock
	WSADATA Data;
	SOCKET sc;

	// Start sockets
	if (WSAStartup(MAKEWORD(1, 1), &Data) != 0)
	{ 
		printf("\n\nFAILED_TO_START_SOCKETS"); 
		exit(1); 
	}

	// Create Socket
	if ((sc = socket(PF_INET,SOCK_STREAM,0)) == INVALID_SOCKET)
	{ 
		printf("\n\nFAILED_TO_OBTAIN_SOCKET_HANDLE"); 
		exit(1); 
	}

	// Resolve the host email server IP
	// You need the host name of your mail server here
	struct hostent* adr;
	adr = gethostbyname(v_host);
	if (!adr)
	{ 
		printf("\n\nFAILED_TO_RESOLVE_HOST"); 
		exit(1); 
	}

    // Check for a dotted-IP address string
    // If not an address, then try to resolve it as a hostname
    u_long lAddr = inet_addr (v_host);
    if ((lAddr == INADDR_NONE) && (strcmp(v_host, "255.255.255.255"))) 
	{
		LPHOSTENT lpstHost = gethostbyname(v_host);
		if (lpstHost) 
		{  
			lAddr = *((u_long FAR *) (lpstHost->h_addr));	// Success
		} 
		else
		{  
			lAddr = INADDR_ANY;	// Failure
		}
	}

	// Connect to server
	SOCKADDR_IN sin;
	sin.sin_family = AF_INET;
	sin.sin_port = htons(25);
	sin.sin_addr.S_un.S_addr = lAddr;
	if (connect(sc,(LPSOCKADDR)&sin,sizeof(sin)))
	{
		printf("\n\nFAILED_TO_CONNECT");
		exit(1);
	}

	// Get the server welcome message
	Ack(sc); 

	// Get our own host name
	#define LOCAL_HOST_NAME_LEN 256
	char *LocalHost= new char[LOCAL_HOST_NAME_LEN];
	if (gethostname(LocalHost,LOCAL_HOST_NAME_LEN))
	{
		printf("gethostname() failed. Winsock error code is %d\n", WSAGetLastError());
		exit(1);
	}

	char *buf = (char *) malloc(1024*16); // 16 kb dynamic buffer

	// Estblish an email conversation with the server
	sprintf(buf,"HELO %s\r\n", LocalHost); 
	Post(sc,buf); 	
	Ack(sc);	

	// Set the sender email id
	sprintf(buf,"MAIL FROM:<%s>\r\n", v_sender); 
	Post(sc,buf); 
	Ack(sc);

	// Set the target email id
	sprintf(buf,"RCPT TO:<%s>\r\n", v_receiver); 
	Post(sc,buf); 
	Ack(sc);

	// Indicate to the server that we are sending the email data
	Post(sc,"DATA\r\n"); 
	Ack(sc);

	// Print message header according to RFC822 specs
	// See http://ds.internic.net/rfc/rfc822.txt for more info
	char *p;
	char *pbuf = p = new char[1024 * 10]; // 10 KB reserved for header

	// Adds the X-Sender to the email header
	//p += sprintf(p,"X-Sender: %s\n","me@us.oracle.com");

	// Adds the X-Mailer to the email header
	//p += sprintf(p,"X-Mailer: %s %s\r\n","MarcMail", "1.1");

	// Adds the REPLY-TO field
	//p += sprintf(p,"Reply-To: %s\r\n", "me@us.oracle.com");

	// If email agent didn't support mime encoding we wouldn't use the following:
	//p += sprintf(p,"Mime-Version: %s\r\n", "1.0");

	  p += sprintf(p,"Content-Type: text/plain; charset=us-ascii\r\nContent-Transfer-Encoding: 7-bit\r\n");
	// Set up the DATE field  ... yes ... it's busy code
	time_t tNow = time(NULL);
	struct tm *tm = localtime(&tNow);
	char *days[] = {"Sun", "Mon","Tue", "Wed", "Thu", "Fri", "Sat"};
	char *months[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
						"Aug", "Sep", "Oct", "Nov", "Dec"};
	extern int _daylight;
	extern long _timezone;
	extern char *_tzname[2];
	int zoneh = abs(_timezone) / (60 * 60);
	int zonem = (abs(_timezone) / 60) - (zoneh * 60);
	p += sprintf(p, "Date: %s, %02d %s %04d %02d:%02d:%02d %s%02d%02d\r\n",
		days[tm->tm_wday], tm->tm_mday, months[tm->tm_mon], tm->tm_year + 1900,
		tm->tm_hour, tm->tm_min, tm->tm_sec, 
//		(_timezone > 0) ? "+" : (_timezone < 0) ? "-" : "",
		(_timezone > 0) ? "-" : (_timezone < 0) ? "+" : "",
		zoneh, zonem);

	// Set the FROM field
	// I'm omitting this so it defaults to the MAIL FROM value
	// NB: This does strange things with simple names ... treats them like an alias!!!
	//p += sprintf(p,"From: %s\r\n", "me@us.oracle.com");

	// Set the SUBJECT field
	p += sprintf(p,"Subject: %s\r\n", v_subject);

	// Set the TO field
	p += sprintf(p,"To: %s\r\n", v_receiver);

	// Set the CC field
	// NB: You have to include this recipient in the RCPT TO value
	//p += sprintf(p,"Cc: %s\r\n", "youtoo@us.oracle.com");

	// Post the email header
	Post(sc,pbuf);
	delete pbuf;

	// Submit an empty line to indicate end of email header
	Post(sc,"\r\n");

	// Submit the email body
	Post(sc,v_body);

	// Indicates the end of the message body
	Post(sc,"\r\n.\r\n");
	Ack(sc);

	// Quits out of the mail session
	Post(sc,"QUIT\r\n"); 
	Ack(sc);
   
	return;
}

// This routine posts data to the mail server
BOOL Post(SOCKET sc, LPCSTR msg)
{
	int len = strlen(msg);
	int slen;
	int index = 0;

	#ifdef DEBUG 
		printf("Posting: %s", msg);
	#endif

	while(len > 0)
	{
		// This 'sends' data to the socket
		if ((slen = send(sc,msg + index,len,0)) < 1)
		{
			exit(1);	// FAILED_TO_SEND
			return FALSE;
		}
		len -= slen;
		index += slen;
	}
	return TRUE;
}

// This routine gets the response from the server
BOOL Ack(SOCKET sc)
{
	static char *buf;
	int rlen;
	int Index = 0;
	int Received = 0;

	if (!buf)
		if ((buf = (char *)malloc(1024 * 4)) == NULL)
			exit(1);	// OUT_OF_MEMORY

again:
	if ((rlen = recv(sc,buf + Index,((1024 * 4) - 1) - Received,0)) < 1)
	{
		exit(1);	// FAILED_TO_RECEIVE
		printf("Error: Unable to receive from host\n");
		return FALSE;
	}
	Received += rlen;
	buf[Received] = 0;
	#ifdef DEBUG 
		printf("Received: (%d bytes) %s", rlen, buf + Index);
	#endif

	// Check for newline
	Index += rlen;
	if ((buf[Received -2] != '\r') || (buf[Received -1] != '\n'))
	{
		printf("Incomplete server message. Awaiting CRLF\n");
		goto again; // Incomplete data. Line must be terminated by CRLF
	}

	if (buf[0] > '3')
	{
		// Error code
		printf("SMTP server error: %s\n", buf);
		exit(1);
		return FALSE;
	}
	return TRUE;
}